if(jQuery) {
	var mobileVersion = false;
	if(jQuery.mobile.version >= '1.4.0') {
		mobileVersion = true;
	}
	if(isCollapsible(node)) {
		if(isCollapsed(node)) {
			if(!mobileVersion) {
				jQuery(node).trigger('expand');
			} else {
				/* 	
					For jQuery-mobile >= 1.4.0 triggering collapse|expand methods won't work 
					anymore, now there are methods for collapsible widget, so we need to get 
					the collapsible element and invoke the respected method (expand|collapse).
				*/
				jQuery(getCollapsible(node)).collapsible('expand');
			}
			com.ibm.rpe.Editor.repaint();
		} else {
			if(!mobileVersion) {
				jQuery(node).trigger('collapse');
			} else {
				jQuery(getCollapsible(node)).collapsible('collapse');
			}
			com.ibm.rpe.Editor.repaint();
		}
	}
}

function isCollapsible(node) {
	if(jQuery(getAncestor(node, 0)).hasClass('ui-collapsible-heading-toggle')
	|| jQuery(getAncestor(node, 1)).hasClass('ui-collapsible-heading-toggle')) {
		return true;
	}
	return false;
}

function getAncestor(node, level) {
	var ancestor = node;
	if(!mobileVersion) {
		ancestor = ancestor.parentNode;
	}
	while(level--) {
		ancestor = ancestor.parentNode;
	}
	return ancestor;
}

function isCollapsed(node) {
	if(jQuery(getAncestor(node, 2)).hasClass('ui-collapsible-collapsed')
	|| jQuery(getAncestor(node, 3)).hasClass('ui-collapsible-collapsed')) {
		return true;
	}
	return false;
}

function getCollapsible(node) {
	var collapsibleNode = getAncestor(node, 2);
	if(jQuery(collapsibleNode).hasClass('ui-collapsible')) {
		return collapsibleNode;
	} else {
		collapsibleNode = getAncestor(node, 3);
		if (jQuery(collapsibleNode).hasClass('ui-collapsible')) {
			return collapsibleNode;
		} else {
			return node;
		}
	}
}