// set the overflow style on the "scrolling" element to hidden so that RPE owns the scrolling behavior with its scrollbars
// the element that determines scrolling of the page contents varies with doctype - it's either the html or body element
var docPage = (document.compatMode == "BackCompat") ? document.body: document.documentElement;  // distinguish quirks vs. strict mode doctype issues
docPage.style.overflow = 'hidden';

// prevent the "other" element from scrolling
var otherNode = (docPage == document.body) ? document.documentElement : document.body;
otherNode.style.overflow = 'visible';


// now check for the browser capabilities - if this critical DOM function doesn't exist then basically
// none of our interactive scripts (ex. DnD, selection) are going to work - we'll invoke a callback to
// disable the design pane if such a backlevel browser is found
if((typeof document.body.getBoundingClientRect) === 'undefined') {
	IBMRPE_bad_browser();
}

//logic for self-removing the containing script node - we don't want this node lying around polluting the DOM as a child of the body tag because it makes the add/remove dom-sync scenarios that much trickier
var thisNode = document.getElementById('{0}');
if(thisNode) {
	thisNode.parentNode.removeChild(thisNode);
}
