// force there to always be a WL.Client.init function - this needs to be called to bootstrap the page
if(!WL) {
	WL = {};
}
if(!WL.Client) {
	WL.Client = {};
}
if(!WL.Client.init) {
	WL.Client.init = new function() {};
}

// now that we've defined the structure (if necessary) this check will always be true
// if we can guarantee the WL scripts injected to the page always work correctly the lines above could be removed
if(WL && WL.Client && WL.Client.init) {
	WL.Client.init = function(options) {
		// for displaying a WL page inside RPE, we don't really care about most of the init logic.
		// since there may be various problems running some of the WL code on a desktop browser
		// as opposed to a mobile device, we're extracting just the important pieces of the init
		// logic as far as visualizations are concerned.
		try {
	        if (window.wlEnvInit !== undefined) {
	            wlEnvInit();
	        } else if (window.wlCommonInit !== undefined) {
	            wlCommonInit();
	        }
		} finally {
			// make sure the body itself can be seen
	        document.body.style.display = 'block';
		}
	}
}
