// Make this hack to identify if it's running in Mozilla, so we can insert
// it everywhere without breaking other browsers correct behavior
if (navigator.userAgent.indexOf('Mozilla') > -1) {
	
	// needed to get jQuery Mobile 1.3 to work with our ancient xulrunner version
	var originalGetComputedStyle = window.getComputedStyle;
	window.getComputedStyle = function(el) {
		return originalGetComputedStyle(el, '');
	};
	
	// needed to get jQuery core 2.0 to work with our ancient xulrunner version
	if (!Array.isArray) {
		Array.isArray = function(arg) {
			return Object.prototype.toString.call(arg) === '[object Array]';
		};
	}
	if (!Object.defineProperty) {
		Object.defineProperty = function(obj, property, config) {
			if (obj.__defineGetter__ && config.get) {
				obj.__defineGetter__(property, config.get);
			}
			if (obj.__defineSetter__ && config.set) {
				obj.__defineSetter__(property, config.set);
			}
			return obj;
		};
	}
	if (!Object.defineProperties) {
		Object.defineProperties = function(obj, properties) {
			for (var k in properties) {
				// Kind of a hack, because we know that jQuery is setting the value property in the descriptor
				obj[k] = properties[k].value;
			}
			return obj;
		};
	}
	if (!Object.keys) {
		Object.keys = function(obj) {
			var keys = [];
			for (var k in obj) {
				if (obj.hasOwnProperty(k)) {
					keys.push(k);
				}
			}
			return keys;
		};
	}

}