// setup namespace objects
if(!com) {
	var com = {};
}
if(!com.ibm) {
	com.ibm = {};
}
if(!com.ibm.rpe) {
	com.ibm.rpe = {};
}

if(!com.ibm.rpe.jQueryHelper) {
	com.ibm.rpe.jQueryHelper = function() {}
}

com.ibm.rpe.jQueryHelper.createWidget = function(nodeId) {
try {
	if (typeof jQuery != 'undefined') {
		(function($) {
			var node = $('[vizid='+nodeId+']');
			var role = node.attr('data-role');
			if (role == 'footer' || role == 'header' || role == 'content') { // jQuery cannot enhance content when triggering 'create' on footer/header/content [https://github.com/jquery/jquery-mobile/issues/2215]
				node.closest('[data-role="page"]').trigger('pagecreate').trigger('create');
			}
			else {
				if (role == 'page' || role == 'dialog' || role == 'panel') {
					if ($.mobile.activePage && $.mobile.activePage.attr('vizid') == nodeId) {
						$.mobile.changePage(node, { allowSamePageTransition: true, transition: 'none', reloadPage: true, role: role });
					}
				}
				else {
					var parent = node.parent();
					if (parent.attr('data-role') == 'controlgroup' || parent.attr('data-role') == 'collapsible-set') {
						parent = parent.parent();
					}
					parent.trigger('create');
				}

			}
			// Make sure any fixed header/footer adjusts its page's padding and min-height
			node.closest('.ui-header.ui-header-fixed,.ui-footer.ui-footer-fixed').each(function(i) {
				var self = $(this);
				var page = self.closest('.ui-page');
				page.css('padding-' + (self.is('.ui-header') ? 'top' : 'bottom'), self.outerHeight());
				page.css('min-height', $.mobile.getScreenHeight() - parseFloat(page.css("padding-top")) - parseFloat(page.css("padding-right")) - parseFloat(page.css("padding-bottom")) - parseFloat(page.css("padding-left")));
			});
		})(jQuery);
	}
}catch (e) { log(e.message); }
}

com.ibm.rpe.jQueryHelper.drawBorderOnContainerElements = function() {

	var applyChanges = (
		function(selector, message, hasChildren, noBorderWhenEmpty, noTopBorder) {
			jQuery(selector).each(function(index) {
				var childrenPresent = hasChildren(this);
				if(!noBorderWhenEmpty || !childrenPresent) {
					var jQueryObject = jQuery(this);
					jQueryObject.css('border-style', 'dashed').css('border-color', 'grey').css('border-width', '1px').css('margin','-1');
					if(noTopBorder) {
						jQueryObject.css('border-top', 'none');
					}
				}
				if(!childrenPresent) {
					this.innerHTML = "<div align=center style=\"color: grey;line-height:40px\">" + message + '</div>';
				}
			});
		}
	);
	
	var hasChildren = (
		function(node) {
			var jQueryObject = jQuery(node);
			return !(jQueryObject.children().length == 0 && jQuery.trim(jQueryObject.text()).length == 0);
		}
	)
	
	var controlGroupHasChildren = (
		function(node) {
			if(node.childNodes.length == 1) {
				var child = node.firstChild;
				var content = jQuery.trim(jQuery(child).text());
				return child.tagName == 'DIV' && child.getAttribute('data-role') == null && !(content.length == 0);
			}
			return true;
		}
	);
	
	applyChanges("[data-role='content']", '{0}', hasChildren, false, false);
	applyChanges("[data-role='fieldcontain']", '{2}', hasChildren, false, false);
	applyChanges("[data-role='controlgroup']", '{3}', controlGroupHasChildren, false, false);
	applyChanges("[data-role='collapsible-set']", '{4}', hasChildren, true, false);
	applyChanges("[data-role='collapsible'] > div.ui-collapsible-content", '{0}', hasChildren, false, true);
	applyChanges("[data-role='listview']", '{5}', hasChildren, true, false);
	applyChanges("[data-role='tabs']", '{0}', hasChildren, false, false);
	if($.mobile){
		applyChanges("form:not([role])", '{1}', hasChildren, false, false);
	}
}


com.ibm.rpe.jQueryHelper.drawBorderOnGridElements = function() {

	var getTallest = (function getTallest(nodes) {
		var tallest = 0;
		nodes.each(function() {
			var thisHeight = jQuery(this).height();
			if (thisHeight > tallest) {
				tallest = thisHeight;
			}
		});
		return tallest;
	});

	jQuery(".ui-grid-solo, .ui-grid-a, .ui-grid-b, .ui-grid-c, .ui-grid-d", jQuery.mobile.activePage[0]).filter("div").each(function() {
		var jQueryGridObject = jQuery(this);
		jQuery(".ui-block-a", this).each(function() {
			var nodes = jQuery(this).nextUntil('.ui-block-a').add(this);
			var height = getTallest(nodes) + 2;
			var emptyBlockFound = false;
			nodes.each(function(){
				var jQueryObject = jQuery(this);
				if(height < 30) {
					emptyBlockFound = true;
					height = 50;
				}
				var fontSize = "medium";
				if(jQueryObject.width() < 80) {
					fontSize = "xx-small"
				} else if(jQueryObject.width() < 120) {
					fontSize = "x-small"
				}
				if(jQueryObject.children().length == 0 && jQuery.trim(jQueryObject.text()).length == 0) {
					this.innerHTML = "<div align=center style=\"font-size:" + fontSize + ";color: grey;line-height:" + height + "px\">{0}</div>";
				}
			});
			if(nodes.length > 1 || emptyBlockFound) {
				nodes.css('height', height);
			}
		});
	});
	jQuery(".ui-grid-solo, .ui-grid-a, .ui-grid-b, .ui-grid-c, .ui-grid-d, .ui-block-a, .ui-block-b, .ui-block-c, .ui-block-d, .ui-block-e").filter('div').css('border-style', 'dashed').css('border-color', 'grey').css('border-width', '1px').css('margin','-1');
}


if({6}) {

	function executeOverride() {
		jQuery("[data-role='collapsible']").each(function(){
			com.ibm.rpe.jQueryHelper.createWidget(com.ibm.rpe.Editor.getNodeId(this));
		});
		jQuery(document).ready(com.ibm.rpe.jQueryHelper.drawBorderOnContainerElements);
		jQuery(document).ready(com.ibm.rpe.jQueryHelper.drawBorderOnGridElements);
	}

	// we need to guarantee that we run the overrides after other scripts may have also required module imports
	if(window.addEventListener) {
		window.addEventListener('load', executeOverride, false);
	} else if(window.attachEvent) {
		// IE
		window.attachEvent('onload', executeOverride);
	} else {
		// if all else fails, do it the ancient way
		var func = window.onload;
		window.onload = function() {
			func && func();
			executeOverride();
		}
	}
}