package org.eclipse.swt.browser;
/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.webpage.template
 *
 * (C) Copyright IBM Corporation 2003, 2006. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
import java.io.File;
import java.io.IOException;

import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Platform;
import org.osgi.framework.Bundle;

public class XULRunnerInitializer {
	private static final String XULRUNNER_PLUGIN="com.ibm.etools.webedit.xulrunner";
	private static final String FOLDER_NAME="xulrunner";
	   static {
		   String os=Platform.getOS();
		   //This block should be executed only in windows
		   if(os.contains("win")){
	        Bundle bundle = Platform.getBundle(XULRUNNER_PLUGIN); //$NON-NLS-1$
	        if (bundle != null) {
	                try {
	                	File bundleDirectory= FileLocator.getBundleFile(bundle);
	                	String folderName=null;
	                	File[] files=null;
	                	if(bundleDirectory!=null)
	                		files=bundleDirectory.listFiles();
	                	if(files!=null)
	                	for(int i=0;i<files.length;i++){
	                	if(files[i].getPath().endsWith(FOLDER_NAME)){
	                		folderName=files[i].getAbsolutePath();
	                		break;
	                		}
	                	}
	                	if(folderName!=null)
	                		System.setProperty("org.eclipse.swt.browser.XULRunnerPath",folderName); //$NON-NLS-1$
	                } catch (IOException e) {
                        e.printStackTrace();
	                } 
	        }
	    }	
	   }

}
